;>extern "mod.prosonix",musadr	; <-- set music module AND lenght 
;>extern "mod.nemesis",musadr
>extern "mod.victory",musadr

; Razor Trainer Menu (coded by Lord Strangelove)

start:
	bset	#1,$bfe001
	move.l	#0,d0
	lea	musadr,a0			;init music
	jsr	0(a0)				;
	lea	start2(pc),a0
	move.l	a0,$80.w
	trap	#0
start2:
	move.w	#$2700,SR
	lea	$dff000.l,a6
	move.w	#$7fff,$096(a6)
	bsr	Init
	Bsr	clearscreen
	bsr	PrintText
	lea	Copper(pc),a0
	move.l	a0,$080(a6)
	clr.w	$088(a6)
	move.w	#$83c0,$096(a6)
mouse:
	bsr	TrainMenu
	btst	#6,$bfe001
	bne.s	mouse
	lea	musadr,a0			;stop music
	jsr	8(a0)				;
	move.l	4.w,a1
	move.l	(a1),a1
	move.l	(a1),a1
	move.l	38(a1),$080(a6)
	move.l	#$fc07fa,$80.w
	move.w	#$0000,SR
	move.w	#$e02c,$09a(a6)
	move.w	#$83f0,$096(a6)
	rts

TrainMenu:
	cmp.b	#$80,$006(a6)
	bne.s	TrainMenu
	movem.l	d0-d7/a0-a6,-(a7)
	lea	musadr,a0			;play music
	jsr	4(a0)				;
	movem.l	(a7)+,d0-d7/a0-a6
	bsr	scroll
	bsr	plot
	bsr	keyget
	rts

Init:
	lea	status(pc),a0
	lea	textstart(pc),a1
	move.l	a1,2(a0)
	move.l	a1,6(a0)
	rts

Plot:
	lea	status(pc),a0
	addq.w	#1,(a0)
	cmp.w	#8,(a0)
	bne.s	NoFont
	clr.w	(a0)

	lea	$41e00+42,a2	; plotposition
	move.l	2(a0),a1
	moveq	#0,d0
	move.b	(a1),d0
	bne.s	AllesKlar
	moveq	#$20,d0
	move.l	6(a0),2(a0)
;	bra	NoFont

AllesKlar:
	bsr	SetFont
	move.b	(a4),(a2)
	move.b	1(a4),42(a2)	
	move.b	2(a4),84(a2)	
	move.b	3(a4),126(a2)	
	move.b	4(a4),168(a2)	
	addq.l	#1,2(a0)
NoFont:
	rts

KeyGet:
	moveq	#0,d0
	move.b	$bfed01.l,d0
	btst	#3,d0
	beq.s	GeneFeil

	move.b	$bfec01,d0
	not.b	d0
	lsr.w	#1,d0
	bcs	NoFont
GeneFeil:
	bset	#6,$bfee01
	moveq	#127,d1
delay:	dbf	d1,delay
	bclr	#6,$bfee01
	cmp.b	#$50,d0
	blt.s	NoFont
	cmp.b	#$57,d0
	bgt.s	NoFont
	sub.b	#$50,d0
	lea	Coords(pc),a0
	lea	Buttons(pc),a1
	lea	On(pc),a2
	lea	Off(pc),a3
	not.b	(a1,d0.w)
	tst.b	(a1,d0.w)
	bne.s	TrainerOn

	bsr.s	TestPos
	move.b	(a0)+,(a3)
	move.b	(a0)+,1(a3)
	move.l	a3,a0
	bsr	text2
	rts

TestPos:
	add.w	d0,d0
	lea	(a0,d0.w),a0
	rts

TrainerOn:
	bsr.s	TestPos
	move.b	(a0)+,(a2)
	move.b	(a0)+,1(a2)
	move.l	a2,a0
	bsr	text2
	rts

ClearScreen:
	lea	$40000,a0
	move.w	#2000,d0
ClearLoop:
	clr.l	(a0)+
	dbf	d0,ClearLoop
	rts

Scroll:
	btst	#14,$002(a6)
	bne.s	scroll
	move.l	#$41e02,$050(a6)
	move.l	#$41e00,$054(a6)
	move.l	#$f9f00000,$040(a6)
	move.l	#$ffffffff,$044(a6)
	clr.l	$064(a6)
	move.w	#%0000000110010101,$058(a6)
;		  hhhhhhhhhhwwwwww
	rts

PrintText:
	lea	MenuText(pc),a0
Text2:
	lea	$40000,a1
	lea	Font(pc),a3
Looper:
	moveq	#0,d0
	move.l	d0,d1
	move.b	(a0)+,d0
	move.b	(a0)+,d1
	mulu	#[6*40],d1
	add.w	d1,d0
	lea	(a1,d0.w),a2	; dest

PrintLoop:
	moveq	#0,d0
	move.b	(a0)+,d0
	beq.s	Looper
	cmp.b	#$ff,d0
	beq.s	End
	bsr	SetFont
	move.b	(a4),(a2)
	move.b	1(a4),40(a2)	
	move.b	2(a4),80(a2)	
	move.b	3(a4),120(a2)	
	move.b	4(a4),160(a2)	
	addq.l	#1,a2
	bra.s	PrintLoop	
End:
	rts

SetFont:
	sub.b	#$20,d0
	mulu	#5,d0
	lea	(a3,d0.w),a4
	rts

Copper:
	dc.l	$01800000
	dc.l	$3309fffe,$0180055f
	dc.l	$3409fffe,$01800004
	dc.l	$008e3671,$0090f4c1,$00920038,$009400d0
	dc.l	$00e00004,$00e20000,$01001200,$01020000
	dc.l	$01080000,$0182066f
	dc.l	$e609fffe,$01080002
	dc.l	$00e00004,$00e21e02
	dc.l	$eb09fffe,$01000000
	dc.l	$f009fffe,$0180055f
	dc.l	$f109fffe,$01800000
	dc.l	$fffffffe

status:
	dc.w	0
	dc.l	0
	dc.l	0

Coords:
	dc.b	30,12
	dc.b	30,14
	dc.b	30,16
	dc.b	30,18
	dc.b	30,20	
	dc.b	30,22
	dc.b	30,24
	dc.b	30,26


textstart:
dc.b '  CALL THE OFFICIAL RAZOR ELITE BOARDS:'
dc.b ' "DIGITAL EXPRESS" ++47-71-21584  - '
dc.b ' "HELLFIRE" ++49-511-2110635  - '
dc.b ' "THE PITCH" ++1-703-569-8477  - '
dc.b ' "WILD SIDE" ++1-312-777-4184/2963  - '
dc.b ' "THE GAMESHOP" ++1-708-215-7832  '
dc.b '      GREETINGS TO ALL OUR FRIENDS IN:'
dc.b ' ANGELS - SKID ROW - VALHALLA - QUARTEX - PARADOX -'
dc.b ' FAIRLIGHT - DEFJAM - HORIZON - DUAL CREW - ANARCHY -'
dc.b ' SCOOPEX - PHENOMENA - BRAINSTORM - NORTH STAR -'
dc.b ' CRYPTOBURNERS - CRUSADERS - AND ALL OTHERS...      '
dc.b 'MAILTRADERS WRITE TO: RAZOR 1911, BRYNSV.15, '
dc.b '7018 TRONDHEIM, NORWAY...        '
dc.b '                            ',0,0
On:
dc.b 0,0,'ON ',$ff
Off:
dc.b 0,0,'OFF',$ff

MenuText:
dc.b	0,0,'----------------------------------------',0
dc.b	6,2,'OPERATION THUNDERBOLT++++++++',0
dc.b	0,4,'----------------------------------------',0
dc.b	11,6,'CRACKED BY ORACLE',0
dc.b	9,8,'IMPROVED BY RAZOR 1911',0
dc.b	0,10,'----------------------------------------',0
dc.b	8,12,'F1 CONTINIOUS FIRE1   OFF',0
dc.b	8,14,'F2 CONTINIOUS FIRE2   OFF',0
dc.b	8,16,'F3 UNLIMITED LIVES1   OFF',0
dc.b	8,18,'F4 UNLIMITED LIVES2   OFF',0
dc.b	8,20,'F5 UNLIMITED AMMO1    OFF',0
dc.b	8,22,'F6 UNLIMITED AMMO2    OFF',0
dc.b	8,24,'F7 UNLIMITED SHELLS1  OFF',0
dc.b	8,26,'F8 UNLIMITED SHELLS2  OFF',0
dc.b	0,28,'----------------------------------------',$ff

Font:
;        01234567  	space 32  
dc.b	%00000000;3	
dc.b	%00000000;4	
dc.b	%00000000;5	
dc.b	%00000000;6	
dc.b	%00000000;7	


;        01234567  	! 33 
dc.b	%00011000;3	
dc.b	%00011000;4	
dc.b	%00011000;5	
dc.b	%00000000;6	
dc.b	%00011000;7	

;        01234567  	" 34 
dc.b	%00011000;3	
dc.b	%00110000;4	
dc.b	%00000000;5	
dc.b	%00000000;6	
dc.b	%00000000;7	

;        01234567  	# 35  
dc.b	%00100100;3	
dc.b	%01111110;4	
dc.b	%00100100;5	
dc.b	%01111110;6	
dc.b	%00100100;7	

;        01234567  	$
dc.b	%01111110;3	
dc.b	%01011000;4	
dc.b	%01111110;5	
dc.b	%00011010;6	
dc.b	%01111110;7	

;        01234567  	%  
dc.b	%00000000;3	
dc.b	%00000000;4	
dc.b	%00000000;5	
dc.b	%00000000;6	
dc.b	%00000000;7	

;        01234567  	&  
dc.b	%00111100;3	
dc.b	%011011100;4	
dc.b	%01111000;5	
dc.b	%01111110;6	
dc.b	%00111100;7	


;        01234567  	.  
dc.b	%00000000;3	
dc.b	%00000000;4	
dc.b	%00000000;5	
dc.b	%00000000;6	
dc.b	%00011000;7	

;        01234567  	(  
dc.b	%00111100;3	
dc.b	%00110000;4	
dc.b	%00110000;5	
dc.b	%00110000;6	
dc.b	%00111100;7	

;        01234567  	)  
dc.b	%00111100;3	
dc.b	%00001100;4	
dc.b	%00001100;5	
dc.b	%00001100;6	
dc.b	%00111100;7	

;        01234567  	*   
dc.b	%01100110;3	
dc.b	%00111100;4	
dc.b	%11111111;5	
dc.b	%00111100;6	
dc.b	%01100110;7	

;        01234567  	+  
dc.b	%00011000;3	
dc.b	%00011000;4	
dc.b	%01111110;5	
dc.b	%00011000;6	
dc.b	%00011000;7	

;        01234567  	,  
dc.b	%00000000;3	
dc.b	%00000000;4	
dc.b	%00000000;5	
dc.b	%00011000;6	
dc.b	%00110000;7	

;        01234567  	-  
dc.b	%00000000;3	
dc.b	%00000000;4	
dc.b	%01111110;5	
dc.b	%00000000;6	
dc.b	%00000000;7	

;        01234567  	.  
dc.b	%00000000;3	
dc.b	%00000000;4	
dc.b	%00000000;5	
dc.b	%00000000;6	
dc.b	%00011000;7	

;        01234567  	/  
dc.b	%00001100;3	
dc.b	%00011000;4	
dc.b	%00110000;5	
dc.b	%01100000;6	
dc.b	%00000000;7	

;        01234567  	0  
dc.b	%01111100;3	
dc.b	%11001110;4	
dc.b	%11010110;5	
dc.b	%11100110;6	
dc.b	%01111100;7	

;        01234567  	1  
dc.b	%00011000;3	
dc.b	%00111000;4	
dc.b	%00011000;5	
dc.b	%00011000;6	
dc.b	%01111110;7	

;        01234567  	2  
dc.b	%01111100;3	
dc.b	%00000110;4	
dc.b	%00111100;5	
dc.b	%01100000;6	
dc.b	%01111110;7	

;        01234567  	3  
dc.b	%01111100;3	
dc.b	%00000110;4	
dc.b	%00111100;5	
dc.b	%00000110;6	
dc.b	%01111100;7	

;        01234567  	4  
dc.b	%11001100;3	
dc.b	%11001100;4	
dc.b	%11111110;5	
dc.b	%00001100;6	
dc.b	%00001100;7	

;        01234567  	5  
dc.b	%01111110;3	
dc.b	%01100000;4	
dc.b	%01111100;5	
dc.b	%00000110;6	
dc.b	%01111100;7	

;        01234567  	6  
dc.b	%00111110;3	
dc.b	%01100000;4	
dc.b	%01111100;5	
dc.b	%01100110;6	
dc.b	%00111100;7	

;        01234567  	7  
dc.b	%11111110;3	
dc.b	%00000110;4	
dc.b	%00001100;5	
dc.b	%00011000;6	
dc.b	%00110000;7	

;        01234567  	8  
dc.b	%00111100;3	
dc.b	%01100110;4	
dc.b	%00111100;5	
dc.b	%01100110;6	
dc.b	%00111100;7	

;        01234567  	9  
dc.b	%00111100;3	
dc.b	%01100110;4	
dc.b	%00111110;5	
dc.b	%00000110;6	
dc.b	%01111100;7	

;        01234567  	:  
dc.b	%00000000;3	
dc.b	%00011000;4	
dc.b	%00000000;5	
dc.b	%00011000;6	
dc.b	%00000000;7	

;        01234567  	;  
dc.b	%00000000;3	
dc.b	%00011000;4	
dc.b	%00000000;5	
dc.b	%00011000;6	
dc.b	%00110000;7	

;        01234567  	<  
dc.b	%00010000;3	
dc.b	%00010000;4	
dc.b	%01111100;5	
dc.b	%01111110;6	
dc.b	%00111100;7	

;        01234567  	=  
dc.b	%00000000;3	
dc.b	%01111100;4	
dc.b	%00000000;5	
dc.b	%01111100;6	
dc.b	%00000000;7	

;        01234567  	>  
dc.b	%01101100;3	
dc.b	%11111110;4	
dc.b	%11111110;5	
dc.b	%01111100;6	
dc.b	%00111000;7	

;        01234567  	?  
dc.b	%00111000;3	
dc.b	%01101100;4	
dc.b	%00001000;5	
dc.b	%00000000;6	
dc.b	%00011000;7	

;        01234567  	alpha  
dc.b	%00000000;3	
dc.b	%00000000;4	
dc.b	%00000000;5	
dc.b	%00000000;6	
dc.b	%00000000;7	

;        01234567  	a  
dc.b	%01111100;3	
dc.b	%11000110;4	
dc.b	%11111110;5	
dc.b	%11000110;6	
dc.b	%11000110;7	

;        01234567  	b  
dc.b	%11111100;3	
dc.b	%11000110;4	
dc.b	%11111100;5	
dc.b	%11000110;6	
dc.b	%11111100;7	

;        01234567  	c  
dc.b	%01111100;3	
dc.b	%11000110;4	
dc.b	%11000000;5	
dc.b	%11000110;6	
dc.b	%01111100;7	

;        01234567  	d  
dc.b	%11111100;3	
dc.b	%11000110;4	
dc.b	%11000110;5	
dc.b	%11000110;6	
dc.b	%11111100;7	

;        01234567  	e  
dc.b	%11111110;3	
dc.b	%11000000;4	
dc.b	%11111100;5	
dc.b	%11000000;6	
dc.b	%11111110;7	

;        01234567  	f  
dc.b	%11111110;3	
dc.b	%11000000;4	
dc.b	%11111100;5	
dc.b	%11000000;6	
dc.b	%11000000;7	

;        01234567  	g  
dc.b	%01111110;3	
dc.b	%11000000;4	
dc.b	%11011110;5	
dc.b	%11000110;6	
dc.b	%01111100;7	

;        01234567  	h  
dc.b	%11000110;3	
dc.b	%11000110;4	
dc.b	%11111110;5	
dc.b	%11000110;	
dc.b	%11000110;	

;        01234567  	i  
dc.b	%11111100;3	
dc.b	%00110000;4	
dc.b	%00110000;5	
dc.b	%00110000;6	
dc.b	%11111100;7	

;        01234567  	j  
dc.b	%11111110;3	
dc.b	%00000110;4	
dc.b	%00000110;5	
dc.b	%11000110;6	
dc.b	%01111100;7	

;        01234567  	k  
dc.b	%11000110;3	
dc.b	%11001100;4	
dc.b	%11111000;5	
dc.b	%11001100;6	
dc.b	%11000110;7	

;        01234567  	l 
dc.b	%11000000;3	
dc.b	%11000000;4	
dc.b	%11000000;5	
dc.b	%11000000;6	
dc.b	%11111110;7	

;        01234567  	m  
dc.b	%11000110;3	
dc.b	%11101110;4	
dc.b	%11111110;5	
dc.b	%11010110;6	
dc.b	%11000110;7	

;        01234567  	n  
dc.b	%11000110;3	
dc.b	%11100110;4	
dc.b	%11111110;5	
dc.b	%11001110;6	
dc.b	%11000110;7	

;        01234567  	o 
dc.b	%01111100;3	
dc.b	%11000110;4	
dc.b	%11000110;5	
dc.b	%11000110;6	
dc.b	%01111100;7	

;        01234567  	p  
dc.b	%11111100;3	
dc.b	%11000110;4	
dc.b	%11111100;5	
dc.b	%11000000;6	
dc.b	%11000000;7	

;        01234567  	q  
dc.b	%01111100;3	
dc.b	%11000110;4	
dc.b	%11000110;5	
dc.b	%11001100;6	
dc.b	%01110110;7	

;        01234567  	r  
dc.b	%11111100;3	
dc.b	%11000110;4	
dc.b	%11111100;5	
dc.b	%11001100;6	
dc.b	%11000110;7	

;        01234567  	s  
dc.b	%01111110;3	
dc.b	%11000000;4	
dc.b	%01111100;5	
dc.b	%00000110;6	
dc.b	%11111100;7	

;        01234567  	t 
dc.b	%11111100;3	
dc.b	%00110000;4	
dc.b	%00110000;5	
dc.b	%00110000;6	
dc.b	%00110000;7	

;        01234567  	u  
dc.b	%11000110;3	
dc.b	%11000110;4	
dc.b	%11000110;5	
dc.b	%11000110;6	
dc.b	%01111100;7	

;        01234567  	v  
dc.b	%11000110;3	
dc.b	%11000110;4	
dc.b	%11000110;5	
dc.b	%01101100;6	
dc.b	%00111000;7	

;        01234567  	w  
dc.b	%11000110;3	
dc.b	%11010110;4	
dc.b	%11111110;5	
dc.b	%11101110;6	
dc.b	%11000110;7	

;        01234567  	x  
dc.b	%11000110;3	
dc.b	%01101100;4	
dc.b	%00111000;5	
dc.b	%01101100;6	
dc.b	%11000110;7	

;        01234567  	y  
dc.b	%11000110;3	
dc.b	%11000110;4	
dc.b	%01111110;5	
dc.b	%00000110;6	
dc.b	%11111100;7	

;        01234567  	z  
dc.b	%11111110;3	
dc.b	%00000110;4	
dc.b	%01111100;5	
dc.b	%11000000;6	
dc.b	%11111110;7	


Buttons:
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0
	dc.b	0

;musadr:	blk.b	12126,0		; <---- set lenght of music module
;musadr:	blk.b	12626,0
musadr:	blk.b	8324,0	
ende:
